import getWindow from "./getWindow.js";
import getNodeName from "./getNodeName.js";
import isTableElement from "./isTableElement.js";
import getTrueOffsetParent from "./getTrueOffsetParent.js";
import getComputedStyle from "./getComputedStyle.js";
export default function getOffsetParent(element) {
  var window = getWindow(element);
  var offsetParent = getTrueOffsetParent(element); // Find the nearest non-table offsetParent

  while (offsetParent && isTableElement(offsetParent)) {
    offsetParent = getTrueOffsetParent(offsetParent);
  }

  if (offsetParent && getNodeName(offsetParent) === 'body' && getComputedStyle(offsetParent).position === 'static') {
    return window;
  }

  return offsetParent || window;
}