import getBasePlacement from "../utils/getBasePlacement.js";
import addClientRectMargins from "../dom-utils/addClientRectMargins.js";
import getLayoutRect from "../dom-utils/getLayoutRect.js";
import getCommonTotalScroll from "../dom-utils/getCommonTotalScroll.js";
import unwrapVirtualElement from "../dom-utils/unwrapVirtualElement.js";
import getMainAxisFromPlacement from "../utils/getMainAxisFromPlacement.js";
import within from "../utils/within.js";
import { left, right } from "../enums.js";
export function arrow(_ref) {
  var _state$modifiersData$;

  var state = _ref.state,
      options = _ref.options,
      name = _ref.name;
  var _options$element = options.element,
      arrowElement = _options$element === void 0 ? '[data-popper-arrow]' : _options$element; // CSS selector

  if (typeof arrowElement === 'string') {
    arrowElement = state.elements.popper.querySelector(arrowElement);

    if (!arrowElement) {
      return state;
    }
  }

  if (!state.elements.popper.contains(arrowElement)) {
    if (undefined !== "production") {
      console.error('Popper: "arrow" modifier\'s `element` must be a child of the popper element.');
    }

    return state;
  }

  state.elements.arrow = arrowElement;
  var popperOffsets = state.modifiersData.popperOffsets;
  var basePlacement = getBasePlacement(state.placement);
  var axis = getMainAxisFromPlacement(basePlacement);
  var isVertical = [left, right].includes(basePlacement);
  var len = isVertical ? 'height' : 'width';
  var arrowElementRect = addClientRectMargins(getLayoutRect(arrowElement), arrowElement);
  var commonTotalScroll = getCommonTotalScroll(unwrapVirtualElement(state.elements.reference), state.scrollParents.reference, state.scrollParents.popper);
  var totalScrollValue = commonTotalScroll[axis === 'y' ? 'scrollTop' : 'scrollLeft'];
  var endDiff = state.measures.reference[len] + state.measures.reference[axis] - popperOffsets[axis] - state.measures.popper[len];
  var startDiff = popperOffsets[axis] - state.measures.reference[axis];
  var centerToReference = endDiff / 2 - startDiff / 2 - totalScrollValue;
  var center = state.measures.popper[len] / 2 - arrowElementRect[len] / 2 + centerToReference; // Make sure the arrow doesn't overflow the popper if the center point is
  // outside of the popper bounds

  center = within(0, center, state.measures.popper[len] - arrowElementRect[len]); // Prevents breaking syntax highlighting...

  var axisProp = axis;
  state.modifiersData[name] = (_state$modifiersData$ = {}, _state$modifiersData$[axisProp] = center, _state$modifiersData$);
  return state;
}
export default {
  name: 'arrow',
  enabled: true,
  phase: 'main',
  fn: arrow,
  requires: ['popperOffsets'],
  optionallyRequires: ['preventOverflow']
};